> ## Documentation Index
> Fetch the complete documentation index at: https://docs.incident.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Update

> Update the details of a custom field



## OpenAPI

````yaml /openapi/deprecated-endpoints.json put /v1/custom_fields/{id}
openapi: 3.0.3
info:
  description: "This is the API reference for incident.io.\n\nIt documents available API endpoints, provides examples of how to use it, and\ninstructions around things like authentication and error handling.\n\nThe API is hosted at:\n\n- https://api.incident.io/\n\nAnd you will need to create an API key via your [incident.io\ndashboard](https://app.incident.io/settings/api-keys) to make requests.\n\n# Making requests\n\nHere are the key concepts required to make requests to the incident.io API.\n\n## Authentication\n\nFor all requests made to the incident.io API, you'll need an API key.\n\nTo create an API key, head to the incident dashboard and visit [API\nkeys](https://app.incident.io/settings/api-keys). When you create the key, you'll be able to choose what actions it\ncan take for your account: choose carefully, as those roles can only be set\nwhen you first create the key. We'll only show you the token once, so make sure\nyou store it somewhere safe.\n\nAPI keys are global to your incident.io account, and can be managed by anyone\nwho has the right permissions. We display the user that created the API key,\nand the API key will remain valid if that user becomes deactivated.\n\nOnce you have the key, you should make requests to the API that set the\n`Authorization` request header using a \"Bearer\" authentication scheme:\n\n```\nAuthorization: Bearer <YOUR_API_KEY>\n```\n\n## Rate Limits\n\nThe incident.io API enforces rate limits to ensure consistent performance for all users.\n\nThe default rate limit is 1200 requests/minute per API key. This limit applies to most endpoints across the API.\n\nSome endpoints have lower rate limits, particularly those that interact with external third-party systems that impose\ntheir own limitations. These specific limits vary by endpoint, and we recommend relying on the rate-limit error\nresponses to understand usage patterns and implement appropriate retry strategies.\n\nWhen you exceed a rate limit, the API will respond with a `429 Too Many Requests` status code, along with a JSON\nresponse that includes information about the limit and when you can retry:\n\n```json\n{\n    \"type\": \"too_many_requests\",\n    \"status\": 429,\n    \"request_id\": \"b839a403-7704-41c1-bf6a-39a2d68caefa\",\n    \"rate_limit\": {\n        \"name\": \"api_key_name\",\n        \"limit\": 1200,\n        \"remaining\": 0,\n        \"retry_after\": \"Thu, 17 Apr 2025 11:17:18 UTC\"\n    },\n    \"errors\": [\n        {\n            \"code\": \"too_many_requests\",\n            \"message\": \"Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.\"\n        }\n    ]\n}\n```\n\nThe response includes:\n* The name of the API key (`name`)\n* The bucket limit (`limit`)\n* The number of requests remaining (`remaining`)\n* When you can retry requests (`retry_after`)\n\n## Errors\n\nWe use standard HTTP response codes to indicate the status or failure of API\nrequests.\n\nThe API response body will be JSON, and contain more detailed information on the\nnature of the error.\n\nAn example error when a request is made without an API key:\n\n```json\n{\n  \"type\": \"authentication_error\",\n  \"status\": 401,\n  \"request_id\": \"8e3cc412-b49d-4957-9073-2c19d2c61804\",\n  \"errors\": [\n    {\n      \"code\": \"missing_authorization_material\",\n      \"message\": \"No authorization material provided in request\"\n    }\n  ]\n}\n```\n\nNote that the error:\n\n- Contains the HTTP status (`401`)\n- References the type of error (`authentication_error`)\n- Includes a `request_id` that can be provided to incident.io support to help\n\tdebug questions with your API request\n- Provides a list of individual errors, which go into detail about why the error\n\toccurred\n\nThe most common error will be a 422 Validation Error, which is returned when the\nrequest was rejected due to failing validations.\n\nThese errors look like this:\n\n```json\n{\n  \"type\": \"validation_error\",\n  \"status\": 422,\n  \"request_id\": \"631766c4-4afd-4803-997c-cd700928fa4b\",\n  \"errors\": [\n    {\n      \"code\": \"is_required\",\n      \"message\": \"A severity is required to open an incident\",\n      \"source\": {\n        \"field\": \"severity_id\"\n      }\n    }\n  ]\n}\n```\n\nThis error is caused by not providing a severity identifier, which should be at\nthe `severity_id` field of the request payload. Errors like these can be mapped to\nforms, should you be integrating with the API from a user-interface.\n\n## Compatibility\n\nWe won't make breaking changes to existing API services or endpoints, but will\nexpect integrators to upgrade themselves to the latest API endpoints within 3\nmonths of us deprecating the old service.\n\nWe will make changes that are considered backwards compatible, which include:\n\n- Adding new API endpoints and services\n- Adding new properties to responses from existing API endpoints\n- Reordering properties returned from existing API endpoints\n- Adding optional request parameters to existing API endpoints\n- Altering the format or length of IDs\n- Adding new values to enums\n\nIt is important that clients are robust to these changes, to ensure reliable\nintegrations.\n\nAs an example, if you are generating a client using an openapi-generator, ensure\nthe generated client is configured to support unknown enum values, often\nconfigured via the `enumUnknownDefaultCase` parameter.\n\nWhen breaking changes are unavoidable, we'll create a new service version on a\nseparate path, and run them in parallel.\n\nFor example:\n\n- https://api.incident.io/v1/incidents\n- https://api.incident.io/v2/incidents\n\nFor any questions, email support@incident.io.\n"
  title: incident.io
  version: 1.0.0
servers:
  - url: https://api.incident.io
security:
  - BearerAuth: []
tags:
  - description: "Manage incident actions.\n\nThese endpoints have been deprecated in favour of Actions V2 and Follow-ups V2, as these\nconcepts have become increasingly separate.\n\nIncidents have two types of actions associated to them:\n\n- Actions, used during an incident response as ephemeral todo lists\n- Follow-ups, actions which are for after the incident and can be exported to external\n\tissue trackers\n\nYou can manage actions in the incident Slack channel with <code>/incident actions</code>, or on\nthe incident homepage.\n\nExporting follow-ups to external issue trackers can be done in the incident homepage.\n"
    name: Actions V1
  - description: >
      Manage and browse catalog resources.


      These endpoints have been deprecated in favour of CatalogV3. The only
      breaking change is

      that the 'manual' attribute mode is now split into 'api' and 'dashboard'.
      We also removed

      the usage of some types that were deprecated in the V2 API. 


      Use the incident.io catalog to track services, teams, product features and
      anything

      else that helps build a map of your organisation. These different
      categories of thing

      become catalog types, and each instance (like a particular service or
      team) is a

      catalog entry.


      Each type is made up of a series of attributes, and each attribute has a
      type. Types

      can even have attributes that refer to other catalog types.


      We automatically create catalog types when you connect an integration,
      such as GitHub

      repositories or PagerDuty services and teams. You can use this API to
      create custom

      types, that are specifically tailored to your organisation.


      Examples might be a 'Service' type with an 'Alert channel' which you can
      point at a

      Slack channel, or 'Team' which specifies its 'Manager' and 'Technical
      Lead' as Slack

      users. You can then use these types to create powerful new workflows.


      Consider using our official [catalog
      importer](https://github.com/incident-io/catalog-importer).

      It can be used to sync catalog data from sources like local files or
      GitHub and push

      them into the incident.io catalog without having to directly interact with
      our public API.
    name: Catalog V2
  - description: >
      Manage custom fields.


      Custom fields are used to attach metadata to incidents, which you can use
      when searching

      for incidents in the dashboard, triggering workflows, building
      announcement rules or for

      your own data needs.


      Each field has a type:


      - Single-select, single value selected from a predefined list of options
      (e.g. Detection Method)

      - Multi-select, as above but you can pick more than one option (e.g.
      Affected Teams)

      - Text, freeform text field (e.g. Customer ID)

      - Link, link URL that is synced to Slack bookmarks on the incident channel
      (e.g. External Status Page)

      - Number, integer or fractional numbers (e.g. # Customers Affected)


      We may add more custom field types in the future - we'd love to hear any
      other types you'd like to use!
    name: Custom Fields V1
  - description: >
      Manage incident roles.


      During an incident, you can assign responders to one of the incident roles
      that are

      configured in your organisation settings.


      Every organisation will have a special 'lead' role, which signifies the
      incident lead or

      commander. This role cannot be deleted, but can be renamed in the
      incident.io dashboard.
    name: Incident Roles V1
  - description: >
      Create and read incidents.


      Incidents are a core resource, on which many other resources (actions,
      etc) are created.


      Care should be taken around these endpoints, as automation that creates
      duplicate

      incidents can be distracting, and impact reporting.


      The maximum page size that can be requested is 250.
    name: Incidents V1
paths:
  /v1/custom_fields/{id}:
    put:
      tags:
        - Custom Fields V1
      summary: Update
      description: Update the details of a custom field
      operationId: Custom Fields V1_Update
      parameters:
        - description: Unique identifier for the custom field
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          in: path
          name: id
          required: true
          schema:
            description: Unique identifier for the custom field
            example: 01FCNDV6P870EA6S7TK1DSYDG0
            type: string
      requestBody:
        content:
          application/json:
            example:
              description: Which team is impacted by this issue
              name: Affected Team
              required: never
              required_v2: never
              show_before_closure: true
              show_before_creation: true
              show_before_update: true
              show_in_announcement_post: true
            schema:
              $ref: '#/components/schemas/CustomFieldsUpdatePayloadV1'
        required: true
      responses:
        '200':
          content:
            application/json:
              example:
                custom_field:
                  catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
                  created_at: '2021-08-17T13:28:57.801578Z'
                  description: Which team is impacted by this issue
                  field_type: single_select
                  id: 01FCNDV6P870EA6S7TK1DSYDG0
                  name: Affected Team
                  options:
                    - custom_field_id: 01FCNDV6P870EA6S7TK1DSYDG0
                      id: 01FCNDV6P870EA6S7TK1DSYDG0
                      sort_key: 10
                      value: Product
                  required: never
                  required_v2: never
                  show_before_closure: true
                  show_before_creation: true
                  show_before_update: true
                  show_in_announcement_post: true
                  updated_at: '2021-08-17T13:28:57.801578Z'
              schema:
                $ref: '#/components/schemas/CustomFieldsUpdateResultV1'
          description: OK response.
      deprecated: true
components:
  schemas:
    CustomFieldsUpdatePayloadV1:
      example:
        description: Which team is impacted by this issue
        name: Affected Team
        required: never
        required_v2: never
        show_before_closure: true
        show_before_creation: true
        show_before_update: true
        show_in_announcement_post: true
      properties:
        description:
          description: Description of the custom field
          example: Which team is impacted by this issue
          type: string
        name:
          description: Human readable name for the custom field
          example: Affected Team
          maxLength: 50
          type: string
        required:
          description: >-
            When this custom field must be set during the incident lifecycle.
            [DEPRECATED: please use required_v2 instead].
          enum:
            - never
            - before_closure
            - always
          example: never
          type: string
        required_v2:
          description: When this custom field must be set during the incident lifecycle.
          enum:
            - never
            - before_resolution
            - always
          example: never
          type: string
        show_before_closure:
          description: >-
            Whether a custom field should be shown in the incident resolve
            modal. If this custom field is required before resolution, but no
            value has been set for it, the field will be shown in the resolve
            modal whatever the value of this setting.
          example: true
          type: boolean
        show_before_creation:
          description: >-
            Whether a custom field should be shown in the incident creation
            modal. This must be true if the field is always required.
          example: true
          type: boolean
        show_before_update:
          description: Whether a custom field should be shown in the incident update modal.
          example: true
          type: boolean
        show_in_announcement_post:
          description: >-
            Whether a custom field should be shown in the list of fields as part
            of the announcement post when set.
          example: true
          type: boolean
      required:
        - name
        - description
        - show_before_creation
        - show_before_closure
        - show_before_update
      type: object
    CustomFieldsUpdateResultV1:
      example:
        custom_field:
          catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
          created_at: '2021-08-17T13:28:57.801578Z'
          description: Which team is impacted by this issue
          field_type: single_select
          id: 01FCNDV6P870EA6S7TK1DSYDG0
          name: Affected Team
          options:
            - custom_field_id: 01FCNDV6P870EA6S7TK1DSYDG0
              id: 01FCNDV6P870EA6S7TK1DSYDG0
              sort_key: 10
              value: Product
          required: never
          required_v2: never
          show_before_closure: true
          show_before_creation: true
          show_before_update: true
          show_in_announcement_post: true
          updated_at: '2021-08-17T13:28:57.801578Z'
      properties:
        custom_field:
          $ref: '#/components/schemas/CustomFieldV1'
      required:
        - custom_field
      type: object
    CustomFieldV1:
      example:
        catalog_type_id: 01FCNDV6P870EA6S7TK1DSYDG0
        created_at: '2021-08-17T13:28:57.801578Z'
        description: Which team is impacted by this issue
        field_type: single_select
        id: 01FCNDV6P870EA6S7TK1DSYDG0
        name: Affected Team
        options:
          - custom_field_id: 01FCNDV6P870EA6S7TK1DSYDG0
            id: 01FCNDV6P870EA6S7TK1DSYDG0
            sort_key: 10
            value: Product
        required: never
        required_v2: never
        show_before_closure: true
        show_before_creation: true
        show_before_update: true
        show_in_announcement_post: true
        updated_at: '2021-08-17T13:28:57.801578Z'
      properties:
        catalog_type_id:
          description: For catalog fields, the ID of the associated catalog type
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        created_at:
          description: When the action was created
          example: '2021-08-17T13:28:57.801578Z'
          format: date-time
          type: string
        description:
          description: Description of the custom field
          example: Which team is impacted by this issue
          type: string
        field_type:
          description: Type of custom field
          enum:
            - single_select
            - multi_select
            - text
            - link
            - numeric
          example: single_select
          type: string
        id:
          description: Unique identifier for the custom field
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        name:
          description: Human readable name for the custom field
          example: Affected Team
          maxLength: 50
          type: string
        options:
          description: >-
            What options are available for this custom field, if this field has
            options
          example:
            - custom_field_id: 01FCNDV6P870EA6S7TK1DSYDG0
              id: 01FCNDV6P870EA6S7TK1DSYDG0
              sort_key: 10
              value: Product
          items:
            $ref: '#/components/schemas/CustomFieldOptionV1'
          type: array
        required:
          description: >-
            When this custom field must be set during the incident lifecycle.
            [DEPRECATED: please use required_v2 instead].
          enum:
            - never
            - before_closure
            - always
          example: never
          type: string
        required_v2:
          description: When this custom field must be set during the incident lifecycle.
          enum:
            - never
            - before_resolution
            - always
          example: never
          type: string
        show_before_closure:
          description: >-
            Whether a custom field should be shown in the incident resolve
            modal. If this custom field is required before resolution, but no
            value has been set for it, the field will be shown in the resolve
            modal whatever the value of this setting.
          example: true
          type: boolean
        show_before_creation:
          description: >-
            Whether a custom field should be shown in the incident creation
            modal. This must be true if the field is always required.
          example: true
          type: boolean
        show_before_update:
          description: Whether a custom field should be shown in the incident update modal.
          example: true
          type: boolean
        show_in_announcement_post:
          description: >-
            Whether a custom field should be shown in the list of fields as part
            of the announcement post when set.
          example: true
          type: boolean
        updated_at:
          description: When the action was last updated
          example: '2021-08-17T13:28:57.801578Z'
          format: date-time
          type: string
      required:
        - id
        - name
        - description
        - field_type
        - show_before_creation
        - show_before_closure
        - show_before_update
        - options
        - created_at
        - updated_at
      type: object
    CustomFieldOptionV1:
      properties:
        custom_field_id:
          description: ID of the custom field this option belongs to
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        id:
          description: Unique identifier for the custom field option
          example: 01FCNDV6P870EA6S7TK1DSYDG0
          type: string
        sort_key:
          default: 1000
          description: Sort key used to order the custom field options correctly
          example: 10
          format: int64
          type: integer
        value:
          description: >-
            Human readable name for the custom field option. Values must not
            start or end with whitespace, or contain tabs or newlines.
          example: Product
          type: string
      required:
        - id
        - custom_field_id
        - value
        - sort_key
      type: object
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: API key from your incident.io dashboard (Settings → API keys)

````